#!/bin/bash

worker_threads=(4)

exs=(artifact.bst.rq_rwlock.out artifact.skiplistlock.rq_bundle.out artifact.tl4x_nosync_ravl.out artifact.tl4x_skiplistmap.out artifact.trinvrtl2_ziptreemap.out artifact.bst.rq_vcas.out artifact.tl4x_disk_ravl.out artifact.tl4x_nosync_skiplistmap.out artifact.tl4x_ziptreemap.out artifact.citrus.rq_bundle.out artifact.tl4x_disk_skiplistmap.out artifact.tl4x_nosync_ziptreemap.out artifact.trinvrtl2_ravl.out artifact.citrus.rq_vcas.out artifact.tl4x_disk_ziptreemap.out artifact.tl4x_ravl.out artifact.trinvrtl2_skiplistmap.out)

names=( bst-rq_rwlock skiplistlock-rq_bundle TL4x-RAVL-NOSYNC  TL4x-SKIPLIST  TL4x-ZIPTREE bst-rq_vcas TL4x-RAVL-DISK TL4x-SKIPLIST-NOSYNC TL4x-ZIPTREE-NOSYNC citrus-rq_bundle TL4x-SKIPLIST-DISK TL4x-ZIPTREE-NOSYNC  TrinityVRTL2-RAVL citrus-rq_vcas TL4x-ZIPTREE-DISK bund_tl4x_ravl TrinityVRTL2-SKIPLIST)

nThreads=30

time=60000

update=(50) 

rqSize=(1000 10000 100000 1000000)

for s in ${rqSize[@]}; do
	for u in ${update[@]}; do
		((d=100-u))
		for ws in ${worker_threads[@]}; do
			((rqs=nThreads-ws))
			fname=res_${u}_${d}_${s}_${time}_${rqs}_${ws}_prefill
			rm $fname
			i=0
			for ex in ${exs[@]}; do
				make persistencyclean >/dev/null ; 
				echo  ./${ex} -i $u -d $d -rq 0 -k 1000000 -rqsize $s -t ${time} -nrq ${rqs} -nwork ${ws} -p
				echo ${names[$i]} $'\t' $(./${ex} -i $u -d $d -rq 0 -k 1000000 -rqsize $s -t ${time} -nrq ${rqs} -nwork ${ws} -p | fgrep throughput | fgrep -e query -e update) >> $fname
				((i=i+1))
			done
			
		done


	done


done




