#!/usr/bin/env python
import os


db_size_option = " --num=1000000"
db_bench_option = " --benchmarks=fillrandom,overwrite,fillseq,readrandom,readwhilewriting"
db_bench_fillseekseq = " --benchmarks=fillseekseq --reads=1000"


#
# Databases
# If you run with pmemkv, make sure to create the folder /mnt/pmem0/pmemkv/
#
db_list = [
    ["bin/db_bench_tl4x", "results_db_bench_tl4x.txt"],
    ["bin/db_bench_tl4x_disk", "results_db_bench_tl4x_disk.txt"],
    ["bin/db_bench_tl4x_nosync", "results_db_bench_tl4x_nosync.txt"],
    ["bin/db_bench_trinvrtl2", "results_db_bench_trinvrtl2.txt"],
    ["~/rocksdb/db_bench --db=/mnt/pmem0/rocksdb --sync --compression_type=none", "results_db_bench_rocksdb_pmem_sync.txt"],
    ["~/rocksdb/db_bench --db=/mnt/pmem0/rocksdb  --compression_type=none", "results_db_bench_rocksdb_pmem_noSync.txt"],
    ["~/rocksdb/db_bench --db=/tmp/rocksdb --compression_type=none", "results_db_bench_rocksdb_disk_noSync.txt"],
    ["~/rocksdb/db_bench --db=/tmp/rocksdb --sync --compression_type=none", "results_db_bench_rocksdb_disk_sync.txt"]
]

# List of threads to run with
thread_list = [
    " --threads=1",
    " --threads=2",
    " --threads=4",
    " --threads=8",
    " --threads=16",
    " --threads=20",
    " --threads=24",
    " --threads=32",
    " --threads=38",
    " --threads=40",
#    " --threads=48",
#    " --threads=64",
    ]

print "\n+++ Running DB benchmarks +++\n"
os.system("mkdir /mnt/pmem0/pmemkv/")
for db in db_list:
    os.system("rm " + db[1])
    os.system("date >> " + db[1])
    for db_thread_option in thread_list:
        for mmap_attempts in range(10):
            os.system("make persistencyclean")
            os.system("sleep 2")
            header = db[0] + db_bench_option + db_size_option + db_thread_option
            print header
            os.system("echo >> " + db[1])
            os.system("echo " + header + " >> " + db[1])
            os.system("echo   >> " + db[1]) 
            ret = os.system(header + " >> " + db[1])
            if ret != 42:  # We retry the mmap() if it gave us the wrong address
                break      
#    print "\nRunning for fillseekseq"
#    for db_thread_option in thread_list:
#        for mmap_attempts in range(10):
#            os.system("make persistencyclean")
#            os.system("sleep 2")
#            header =db[0] + db_bench_fillseekseq + db_size_option + db_thread_option
#            print header
#            os.system("echo >> " + db[1])
#            os.system("echo " + header + " >> " + db[1])
#            os.system("echo   >> " + db[1]) 
#            ret = os.system(header + " >> " + db[1])
#            if ret != 42:  # We retry the mmap() if it gave us the wrong address
#                break      
    os.system("date >> " + db[1])
    
os.system("make persistencyclean")
